/*#define xcs_h       LPC_GPIO2->FIOSET = (1<<0)
#define xcs_l         LPC_GPIO2->FIOCLR = (1<<0)

#define xdcs_h      LPC_GPIO2->FIOSET = (1<<1)
#define xdcs_l        LPC_GPIO2->FIOCLR = (1<<1)

#define xrst_h    LPC_GPIO2->FIOSET = (1<<2)
#define xrst_l      LPC_GPIO2->FIOCLR = (1<<2)
*/
#define DREQ_STATUS()      ((LPC_GPIO4->FIOPIN >> 28) & 0x01)

/** VS10xx SCI Registers */
#define SCI_MODE   0x0   /**< VS10xx register */
#define SCI_STATUS   0x1   /**< VS10xx register */
#define SCI_BASS   0x2   /**< VS10xx register */
#define SCI_CLOCKF   0x3   /**< VS10xx register */
#define SCI_DECODE_TIME   0x4   /**< VS10xx register */
#define SCI_AUDATA   0x5   /**< VS10xx register */
#define SCI_WRAM   0x6   /**< VS10xx register */
#define SCI_WRAMADDR   0x7   /**< VS10xx register */
#define SCI_HDAT0   0x8   /**< VS10xx register */
#define SCI_HDAT1   0x9   /**< VS10xx register */
#define SCI_AIADDR   0xa   /**< VS10xx register */
#define SCI_VOL      0xb   /**< VS10xx register */
#define SCI_AICTRL0   0xc   /**< VS10xx register */
#define SCI_AICTRL1   0xd   /**< VS10xx register */
#define SCI_AICTRL2   0xe   /**< VS10xx register */
#define SCI_AICTRL3   0xf   /**< VS10xx register */

// VS1011 modes
#define SM_DIFF			0
#define SM_LAYER12		1
#define SM_RESET			2
#define SM_OUTOFWAV		3
#define SM_SETTOZERO1	4
#define SM_TESTS			5
#define SM_STREAM		6
#define SM_SETTOZERO2	7
#define SM_DACT			8
#define SM_SDIORD		9
#define SM_SDISHARE		10
#define SM_SDINEW		11
#define SM_SETTOZERO3	12
#define SM_SETTOZERO4	13





void vs1053b_write32Byte (unsigned char *buffer) {
int i;

   while (!DREQ_STATUS());
   xdcs_l;
   for (i = 0; i < 32; i++) {
	   SPIPutChar(buffer[i]);
   }
   xdcs_h;
}



void vs1053b_init (void) {
   // init control pins:
/*   LPC_PINCON->PINSEL4 &= ~(0xFFFF);
   LPC_GPIO2->FIODIR |= 0xFF;       // all pins are outputs
   LPC_GPIO2->FIODIR &= ~(1 << 3); // dreq is input
   LPC_GPIO2->FIOCLR = 0xFF;*/
	InitSPI();
   // CS ist pin 1 (also 0)
   // DCS ist pin 2 (also 1)
   // xReset ist pin 3 (also 2)
   // dreq ist pin 4 (also 3)

   xcs_h;               //xCS is high
   xdcs_h;            //xDCS is high
  xrst_h;            //xReset is high
   delay_ms(100);


   //sinetest
 //    vs1053b_writeRegister(SCI_MODE, 0x0820); // testmode, Reset, No L1-2
 //    vssendSinedata(0x53,0xef,0x6e,126);wait;
 //    vssendSinedata(0x45,0x78,0x69,0x74);wait;

   // set SPI-speed to 1MHz: 120MHz/120
   spi_set_speed(100);
   int MP3Status = 0, MP3Clock = 0, MP3Mode = 0, vsVersion = 0, volume = 0;

   MP3Status = vs1053b_readRegister(SCI_STATUS);
   MP3Clock = vs1053b_readRegister(SCI_CLOCKF);
   MP3Mode = vs1053b_readRegister(SCI_MODE);
   volume = vs1053b_readRegister(SCI_VOL);

   vsVersion = (MP3Status >> 4) & 0x000F;

   vs1053b_writeRegister(SCI_MODE, SM_SDINEW);

   // set SC_MULT=3.5x, SC_ADD=1.0x, recommended -> 0x8800
   // so CLKI = 12,288*3,5 = 43,008MHz
   vs1053b_writeRegister(SCI_CLOCKF, 0x8800);

 // Now set SPI-Clock to 43,008/7 = 8,777MHz.
   // so 6MHz should be okay
   // 120MHz = 6*x; x = 120/6 = 20
//   SPI_ConfigClockRate(20);
//  spi_set_speed(20); // 100MHz / 20 = 5MHz for SPI
  spi_set_speed(10); // 50MHz / 10 = 5MHz for SPI//???? 6=>8,33

   vs1053b_writeRegister(SCI_VOL, 0x1010);
   volume = vs1053b_readRegister(SCI_VOL);
   MP3Clock = vs1053b_readRegister(SCI_CLOCKF);
}








void vs_hellotest(void){
 int MP3Status = 0,j=0,size=0, MP3Clock = 0, MP3Mode = 0, vsVersion = 0, volume = 0;
 unsigned char *p,i=0;

 vs1053b_init();


 /*   while (readedBytes < fileSize) {
      rc1 = f_read(&file1, buffer, sizeof(buffer), &br);
      vs1063_write32Byte(buffer);
      readedBytes += br;
   }*/
 p = xHelloMP3; // Point "p" to the beginning of array

 //while (p <= &xHelloMP3[sizeof(xHelloMP3)-1])
 size=sizeof(xHelloMP3)-1;//1694
 for(j=0;j<size/32;j++){
	   while (!DREQ_STATUS());
	   xdcs_l;
	   for (i = 0; i < 32; i++) {
		   SPIPutChar(xHelloMP3[i+j]);
	   }
	   j++;
	   xdcs_h;
 }



 
   MP3Status = vs1053b_readRegister(SCI_STATUS);
   MP3Clock = vs1053b_readRegister(SCI_CLOCKF);
   MP3Mode = vs1053b_readRegister(SCI_MODE);
   vsVersion = (MP3Status >> 4) & 0x000F;
   volume = vs1053b_readRegister(SCI_VOL);
   lgh(20,1,   MP3Mode);
   lgh(20,6,MP3Clock);
   lgh(20,12,volume);
   lgh(20,18,vsVersion);
   lgh(20,24,MP3Status);
}
