
//================= ds18b20 =============================
//    ____
// ___________
//_____________
// 1   2   3
//GND DAT VCC
//=======================================================
//pinout 0.10
#define owds1820_port 0
#define owds1820_pin 10

//Zuweisung Sensor über id1<<8 + id7
//Doppelbelegung
/*
#define CRC10_ID1   0x79 	//ErdVorl
#define CRC07_ID1   0xA3 	//Erdr�ckl
#define CRCsensor00 0x1A 	//Au�enf�hler
#define CRCsensor01 0x52	//Warmwasser
#define CRCsensor02 0x8e 	//Vorlauf
#define CRCsensor03 0x89 	//R�cklauf
#define CRCsensor04 0xFB 	//Ladepumpe
#define CRCsensor05 0xb2 	//178	//WZ-Luft
#define CRCsensor06 0x6f 	//WZ-Boden
//Vorsicht, Doppelbelegung
#define CRCsensor07 0x95 	//LeLuft
#define CRCsensor08 0x6c   //LeBoden
#define CRCsensor09 0x24	//LuLuft
//Vorsicht, Doppelbelegung
#define CRCsensor10 0x21	//LuBoden
#define CRCsensor11 0x26	//NoLuft
#define CRCsensor12 0x31	//NoBoden
#define CRCsensor13 0x41	//VLunten
#define CRCsensor14 0x79	//erdvl
#define CRCsensor15 0xA3	//erdrl
*/
#define CRCsensor16 0xEE37	//neu
#define CRCsensor17 0x50CC	//neu
int16_t sensor16,sensor17;


//#define NULL 0
void xsei(void){;}
void xcli(void){;}
#include <stdint.h>
#if cortex_m3

#define owds1820_clr pinCLR(owds1820_port,owds1820_pin)
#define owds1820_set pinSET(owds1820_port,owds1820_pin)
#define owds1820_output pinDIRout(owds1820_port,10)
#define owds1820_input pinDIRin(owds1820_port,owds1820_pin)
#define owds1820_val pinVAL(owds1820_port,owds1820_pin)


#else
//atmega avr
//#define owds1820_port C
//#define owds1820_pin 5

#define owds1820_output   (DDR(owds1820_portx) |= 1<<owds1820_pin)
#define owds1820_clr (PORT(owds1820_portx) &= ~(1<<owds1820_pin))
#define owds1820_set (PORT(owds1820_portx) |= 1<< owds1820_pin)
#define owds1820_input (DDR(owds1820_portx) &=~(1<<owds1820_pin))
#define owds1820_val (PIN(owds1820_portx)& (1<<owds1820_pin))
#define  xcli cli
#define  xsei sei
#endif


long bool_ds1820_1=0,zl_sensor=0;
#define ds1820verbose 1



// DS1820 commands
#define MATCH_ROM	0x55
#define SKIP_ROM	0xCC
#define	SEARCH_ROM	0xF0
#define CONVERT_T	0x44
#define READ		0xBE
#define WRITE		0x4E
#define EE_WRITE	0x48
#define EE_RECALL	0xB8
#define	SEARCH_FIRST	0xFF		// start new search
#define	PRESENCE_ERR	0xFF
#define	DATA_ERR		0xFE
#define LAST_DEVICE		0x00		// last device found


int16_t CelsiusTemp,tmp1820ds0;

int16_t tr_au,tr_erdvl,tr_erdrl;
int16_t
tr_ww,tr_vl1,tr_rl,tr_vlo,tr_vlu,tr_wzl,tr_wzb,tr_lel,tr_leb,tr_lul,
tr_lub,tr_nol,tr_nob,tr_vl1alt,tr_rlalt,tr_sollvl,tr_sollww,tr_vlualt,tr_vloalt;


//--------------------------------------------------------------------
unsigned char w1_reset(void)
{
  unsigned char err;

  owds1820_clr;
  owds1820_output;
_delay_us(480);
//  DELAY( DELAY_US( 480 ));			// 480 us
  xcli();
  owds1820_input;
_delay_us(66);
//  DELAY( DELAY_US( 66 ));
  err = owds1820_val;			// no presence detect
  xsei();
_delay_us(414);
//  DELAY( DELAY_US( 480 - 66 ));
  if( (owds1820_val) == 0 )		// short circuit
    err = 1;
_delay_ms(1);//kk ge�ndert 30.12.12
  return err;
}


unsigned char w1_bit_io( unsigned char b )
{
  xcli();
  owds1820_output;
_delay_us(1);
//  DELAY( DELAY_US( 1 ));
  if(b) owds1820_input;
_delay_us(14);
//  DELAY( DELAY_US( 15 - 1 ));
  if( (owds1820_val) == 0 )
    b = 0;
_delay_us(45);
//  DELAY( DELAY_US( 60 - 15 ));
  owds1820_input;
_delay_ms(1);//kk ge�ndert 30.12.12
  xsei();
  return b;
}


unsigned int w1_byte_wr( unsigned char b )
{
  unsigned char i = 8, j;
  do{
    j = w1_bit_io( b & 1 );
    b >>= 1;
    if( j )
      b |= 0x80;
  }while( --i );
  return b;
}


unsigned int w1_byte_rd( void )
{
  return w1_byte_wr( 0xFF );
}

#define idata
unsigned char w1_rom_search( unsigned char diff, unsigned char idata *id )
{
  unsigned char i, j, next_diff;
  char b;

  if( w1_reset() )
    return PRESENCE_ERR;			// error, no device found
  w1_byte_wr( SEARCH_ROM );			// ROM search command
  next_diff = LAST_DEVICE;			// unchanged on last device
  i = 8 * 8;					// 8 bytes
  do{
    j = 8;					// 8 bits
    do{
      b = w1_bit_io( 1 );			// read bit
      if( w1_bit_io( 1 ) ){			// read complement bit
	if( b )					// 11
	  return DATA_ERR;			// data error
      }else{
	if( !b ){				// 00 = 2 devices
	  if( diff > i ||
	    ((*id & 1) && diff != i) ){
	    b = 1;				// now 1
	    next_diff = i;			// next pass 0
	  }
	}
      }
      w1_bit_io( b );     			// write bit
      *id >>= 1;
      if( b )					// store bit
	*id |= 0x80;
      i--;
    }while( --j );
    id++;					// next byte
  }while( i );
  return next_diff;				// to continue search
}


void w1_command( unsigned char command, unsigned char idata *id )
{
  unsigned char i;
  w1_reset();
  if( id ){
    w1_byte_wr( MATCH_ROM );			// to a single device
    i = 8;
    do{
      w1_byte_wr( *id );
      id++;
    }while( --i );
  }else{
    w1_byte_wr( SKIP_ROM );			// to all devices
  }
  w1_byte_wr( command );
}



void start_meas( void ){

  if( owds1820_val ){
    w1_command( CONVERT_T, NULL );
	//PORTC-pc3
    owds1820_set;
	//DDRC
    owds1820_output;			// parasite power on

  }else{
    //uputsnl( "Short Circuit !" );
  }
}


void read_meas( void )
{
 uint8_t i;

 unsigned char id[8], diff;
// unsigned char s[30];
//  unsigned char i;
  int16_t temp;

  for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ){
    diff = w1_rom_search( diff, id );

    if( diff == PRESENCE_ERR ){
        //uputsnl( "No Sensor found" );


#ifdef lcd_goto
#if use_glcd
		glcd_goto(1,6);
		glcd_write ( "No Sensor found" );
#else
		lcd_goto(1,6);
		lcd_write ( "No Sensor found" );
#endif
#endif

#if ds1820verbose
		lcd_goto(1,6);
		lcd_write ( "No Sensor found" );
#endif


	break;
    }

    if( diff == DATA_ERR ){
        //uputsnl( "Bus Error" );
#if use_glcd
#if use_glcd
		glcd_goto(1,6);
		glcd_write( "Bus Error" );
#else
		lcd_goto(1,6);
		lcd_write( "" );
#endif
#endif
#if ds1820verbose
		lcd_goto(1,6);
		lcd_write ( "Bus Error" );
#endif
        break;
		}

if( id[0] == 0x28 || id[0] == 0x10 ){	// temperature sensor
//lcd_goto(1,1);
 //     uputs( "ID: " );
 /*     for( i = 0; i < 8; i++ ){
	sprintf( s, "%02X", id[i] );
//	uputs( s );
	lcd_write( s );
     }*/
      w1_byte_wr( READ );			// read command
      temp = w1_byte_rd();			// low byte
      temp |= (unsigned int)w1_byte_rd() << 8;		// high byte
      if( id[0] == 0x10 )			// 9 -> 12 bit
        temp <<= 3;
//      sprintf( s, "  T: %04X = ", temp );	// hex value
//      uputs( s );
//lcd_goto(2,6);
//	lcd_write( s );
//      sprintf( s, "%4d.%01d�C", temp >> 4, (temp << 12) / 6553 ); // 0.1�C
//      //uputsnl( s );
//lcd_goto(2,1);


/*
if((temp>>10)==0b111111){
//Minusgrad=1;
//temp=~temp;
//lcd_goto(2,5);
//lcd_write("MInus");
//lcd_int((temp >> 4));
CelsiusTemp=(temp >> 4)*10+10+(temp << 12) / 6553 ;
}else{
//Minusgrad=0;
CelsiusTemp=(temp >> 4)*10+(temp << 12) / 6553 ;
}
*/


      //CelsiusTemp=((temp&0b1111000000000000) | (temp>>4) )*10  + (temp << 12) / 6553 ;
      if(gbi(temp,15)){//negativ
      CelsiusTemp=((temp & 0xf000) | (temp>>4) )*10-
      (10-((temp - (temp & 0xfff0))*10+8)/16);
      }else{//positiv
      CelsiusTemp=((temp & 0xf000) | (temp>>4) )*10+((temp - (temp & 0xfff0))*10+8)/16;
      }
      #if ds1820verbose
      		lcd_goto(1,10);
      		lcd_hex (id[7]);
      		lcd_write(":");
      		lcd_int (CelsiusTemp);
      #endif


      if(CelsiusTemp==849||CelsiusTemp==850||CelsiusTemp==851)//kein Messergebnis
      {

      //	lcd_int(CelsiusTemp);			//char
      //	lcd_goto(1,1);


      }else{
      //	lcd_goto(2,1);
      //	lcd_int(CelsiusTemp);			//char
      //	lcd_goto(1,1);
      if(bool_ds1820_1==0){
      lcd_goto(7+zl_sensor,1);
      lw(" ");lcd_hex(id[0]);
      lw(" ");lcd_hex(id[1]);
      lw(" ");lcd_hex(id[2]);
      lw(" ");lcd_hex(id[3]);
      lw(" ");lcd_hex(id[4]);
      lw(" ");lcd_hex(id[5]);
      lw(" ");lcd_hex(id[6]);
      lw(" ");lcd_hex(id[7]);
      lw(": ");li(CelsiusTemp);
      zl_sensor++;
      }


       switch ((id[1]<<8)|id[7])// nach crc-wert sortieren
        {
       case CRCsensor16: sensor16=CelsiusTemp ;break;
       case CRCsensor17: sensor17=CelsiusTemp ;break;
/*
       case (CRCsensor00):
      //for(i=0;i<8;i++){eeprom_write_byte(0x000+i,id[0+i]);}
      tr_au=CelsiusTemp;//}
            break;
          case (CRCsensor01):
      //for(i=0;i<8;i++){eeprom_write_byte(0x010+i,id[0+i]);}
      tr_ww=CelsiusTemp ;
            break;
          case (CRCsensor02):
      //for(i=0;i<8;i++){eeprom_write_byte(0x020+i,id[0+i]);}
      tr_vl1=CelsiusTemp;
            break;
          case (CRCsensor03):
      //for(i=0;i<8;i++){eeprom_write_byte(0x030+i,id[0+i]);}
      tr_rl=CelsiusTemp ;
            break;
          case (CRCsensor04):
      //for(i=0;i<8;i++){eeprom_write_byte(0x040+i,id[0+i]);}
      tr_vlo=CelsiusTemp;
      	      break;
          case (CRCsensor05):
      //for(i=0;i<8;i++){eeprom_write_byte(0x050+i,id[0+i]);}
      tr_wzl=CelsiusTemp ;
      	  break;
          case (CRCsensor06):
      //for(i=0;i<8;i++){eeprom_write_byte(0x060+i,id[0+i]);}
      tr_wzb=CelsiusTemp;
      	  break;


          case (CRCsensor07):
      //for(i=0;i<8;i++){eeprom_write_byte(0x070+i,id[0+i]);}
      if(id[1]==CRC07_ID1){
      tr_erdrl=CelsiusTemp ;	}else{
      tr_lel=CelsiusTemp ;}
      		      break;
          case (CRCsensor08):
      //for(i=0;i<8;i++){eeprom_write_byte(0x080+i,id[0+i]);}
      tr_leb=CelsiusTemp;
      		   break;
          case (CRCsensor09):
      //for(i=0;i<8;i++){eeprom_write_byte(0x090+i,id[0+i]);}
      tr_lul=CelsiusTemp ;
            break;
          case (CRCsensor10):
      //for(i=0;i<8;i++){eeprom_write_byte(0x0A0+i,id[0+i]);}

      if(id[1]==CRC10_ID1){
      tr_erdvl=CelsiusTemp ;	}else{
      tr_lub=CelsiusTemp;		}
            break;


          case (CRCsensor11):
      //for(i=0;i<8;i++){eeprom_write_byte(0x0B0+i,id[0+i]);}
      tr_nol=CelsiusTemp ;
            break;
          case (CRCsensor12):
      //for(i=0;i<8;i++){eeprom_write_byte(0x0C0+i,id[0+i]);}
      tr_nob=CelsiusTemp ;
            break;
          case (CRCsensor13):
      //for(i=0;i<8;i++){eeprom_write_byte(0x0D0+i,id[0+i]);}
      tr_vlu=CelsiusTemp ;
            break;
          case (CRCsensor14):
      if(id[1]==0x4a)tmp1820ds0=CelsiusTemp;else tr_erdvl=CelsiusTemp;
            break;
          case (CRCsensor15):
      tr_erdrl=CelsiusTemp ;
            break;
*/

        }
      }// if 850

      //	sprintf( s, "%02X", id[7] );
      //	lcd_write( s );

      //	lcd_write( " ");






      //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


      #if verbose_ds1820
      //zl_sec_timer0=0;
      //zl_timer0=0;
      #ifdef lcd_goto
      	lcd_goto(1,10);
      	lcd_int(CelsiusTemp);
      	lcd_goto(2,1);
      for(i=0;i<8;i++){
      	lcd_hex(id[i]);
      //	lcd_int(zl_timer0);
      }
      #endif
      #else

      _delay_ms(7);//twi64ok

      #endif




      /*lcd_goto(3,1);
      	lcd_int(id[0]);
      	lcd_write( " ");
      	lcd_int(id[1]);
      	lcd_write( " ");
      	lcd_int(id[2]);
      	lcd_write( " ");
      	lcd_int(id[3]);
      	lcd_write( " ");
      lcd_goto(4,1);
      	lcd_int(id[4]);
      	lcd_write( " ");
      	lcd_int(id[5]);
      	lcd_write( " ");
      	lcd_int(id[6]);
      	lcd_write( " ");
      	lcd_int(id[7]);
      	lcd_write( " ");*/
      /*
      #if use_glcd
      glcd_goto(1,1);
      #else
      lcd_goto(1,1);
      #endif
      */

         }
        }
       // //uputsnl( "" );
      //lcd_write( "" );
      }

      //------------------------------------------------------------------------------
      long ds1820_auslesen_to_global_TR()
         {
      tr_vl1alt=tr_vl1;
      tr_rlalt=tr_rl;
      tr_vlualt=tr_vlu;
      tr_vloalt=tr_vlo;

      sensor16=851;
      sensor17=851;

      tr_au=851;
      tr_ww=851;
      tr_vl1=851;
      tr_rl=851;
      tr_vlo=851;
      tr_wzl=851;
      tr_wzb=851;
      tr_lel=851;
      tr_leb=851;
      tr_lul=851;
      tr_lub=851;
      tr_nol=851;
      tr_nob=851;
      tr_vlu=851;
      tr_erdvl=851;
      tr_erdrl=851;
      uint8_t  durchlauf;

      start_meas();
      #if use_wdt
      //wdt_reset(7);
      #endif
      _delay_ms(1000);
      #if use_wdt
      //wdt_reset(7);
      #endif
      read_meas();
      #if use_wdt
      //wdt_reset(7);
      #endif
      bool_ds1820_1++;
      /*
      _delay_ms(1000);
      #if use_wdt
      //wdt_reset(7);
      #endif
      start_meas();
      #if use_wdt
      //wdt_reset(7);
      #endif
      _delay_ms(1000);
      #if use_wdt
      //wdt_reset(7);
      #endif
      read_meas();
      */



      #if use_wdt
      //wdt_reset(7);
      #endif
      /*  init_timer();
       second = 0;
       durchlauf=0;
       while(durchlauf<3)				// main loop
        { if( second == 1 ){start_meas();second = 2;}
          if( second == 3 ){read_meas();second = 0;durchlauf++;}
        }
        */
      #ifdef lcd_goto
        	lcd_goto(1,10);
      	lcd_int(CelsiusTemp);
      #endif
       return (CelsiusTemp);
       }


